; ##############################################################################
; ##############################################################################
; ##############################################################################
SLEEP_INITIALISIEREN:
	ldi temp,(1<<SE)|(0<<SM2)|(0<<SM1)|(0<<SM0)|(0<<ISC11)|(0<<ISC10)|(0<<ISC01)|(0<<ISC00) 
	out MCUCR,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Interrupt, bei CTC 															
TIMER_AKTIVIEREN:
	ldi temp,(1<<OCIE2)|(0<<TOIE2)|(0<<TICIE1)|(0<<OCIE1A)|(0<<OCIE1B)|(0<<TOIE1)|(1<<TOIE0)
	out TIMSK,temp       
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; BERWACHUNGSTIMER																
TIMER0_INITIALISIERUNG:
; TIMER0 (8Bit) Vorteiler													
;																			
; CS02 CS01 CS00 	Description												
;	0 	0 	0 		No clock source (Timer/Counter stopped).				
; *	0 	0 	1 		clkI/O/		(No prescaling)								
;	0 	1 	0 		clkI/O/8 	(From prescaler)							
; 	0 	1 	1 		clkI/O/64 	(From prescaler)							
; 	1 	0 	0 		clkI/O/256 	(From prescaler)							
; 	1 	0 	1 		clkI/O/1024 (From prescaler)							
;	1 	1 	0 		External clock source on T0 pin. Clock on falling edge.	
;	1 	1 	1 		External clock source on T0 pin. Clock on rising edge.	
	ldi temp,(0<<CS02)|(0<<CS01)|(1<<CS00)
	OUT TCCR0,temp
	; TIMER0 Startwert		
	out TCNT0,TIMER0WERT
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; TEST-GENERATOR																
TIMER1_CTC_INITIALISIERUNG:
; Vorteiler													
; cs12 cs11 cs10											
;	0 	0 	0 	No clock source. (Timer/Counter stopped)	
; *	0 	0 	1 	clkI/O/1 (No prescaling)					
;	0 	1 	0 	clkI/O/8 (From prescaler)					
;	0 	1 	1 	clkI/O/64 (From prescaler)					
;	1 	0 	0 	clkI/O/256 (From prescaler)					
;	1 	0 	1 	clkI/O/1024 (From prescaler) 				
   	ldi     r16,(1<<wgm12|0<<cs12|0<<cs11|1<<cs10)  
   	out     tccr1B,r16 
	;  Compare Output Mode 										
   	ldi temp, (0<<COM1A1)|(1<<com1A0)
   	out TCCR1A,temp
	; Frequenz einstellen										
    ldi     temp,high(TIMER1CTC)                 
    out     ocr1AH, temp             
   	ldi     temp,low(TIMER1CTC)
   	out     ocr1AL,temp              
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 57kHz-GENERATOR maximal +/- 11Hz, sonst kann Signal nicht decodiert werden !!!
TIMER2_CTC_INITIALISIERUNG:
; Vorteiler / Output Mode									
; cs22 cs21 cs20											
;  0    0    1 clkT2S/(No prescaling)						
;  0    1    0 clkT2S/8 (From prescaler)					
;  0    1    1 clkT2S/32 (From prescaler)					
;  1    0    0 clkT2S/64 (From prescaler)					
;  1    0    1 clkT2S/128 (From prescaler)					
;  1    1    0 clkT2S/256 (From prescaler)					
;  1    1    1 clkT2S/1024 (From prescaler)					
   ldi     temp,(1<<com20|1<<wgm21|0<<cs22|0<<cs21|1<<cs20)  
   out     tccr2,temp 
	; TIMER-2 Frequenz einstellen	
    ldi     temp,(TIMER2CTC57kHz)
   	out     OCR2,temp              
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; PHASENGLEICHLAUF																
TIMER_SYNCHRONISATION:
	; Timer 1 Startwert 	
	out tcnt1H,NULL
	out tcnt1L,NULL
	; TIMER2 Startwert		
	ldi temp, 0
	out TCNT2,temp
	; Timer 0 Startwert 	
	ldi temp, 0
	out TCNT0,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TIM0_OVF:
	; berwachungstimer beit zu	
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  an	
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
